Option Strict Off
Option Explicit On
Imports Microsoft.VisualBasic.PowerPacks.Printing.Compatibility.VB6
Friend Class frmCTDesign
	Inherits System.Windows.Forms.Form
    Public DCR As Single
    Private IsInitializing As Boolean
	
	Private Sub Hall()
		' Call Error Routine to make sure all data entries are legitimate
        Dim intError As Integer
		Call ErrorHall(intError)
		On Error Resume Next
		' Declare needed variables
		Dim Vout As Single
		Dim dVdB As Single
		Dim N As Short
		Dim Ipri As Single
		Dim Thick As Single
		Dim Conductor As Single
        Dim j, i, intMsg As Integer
        Dim intSmall As Integer
		Dim EffPerm As Single
		Dim CorePerm As Single
		Dim Gap As Single
		Dim Range As Single
		Dim Core(26, 12) As Object
		Dim Perm As Single
		Dim Bmax As Single
		Dim CoreIDMin As Single
		Dim le As Single
		' Make calculations to dtermine core size (based on Min ID)
		intMsg = 0
		Vout = CSng(txtVoltage.Text)
		Thick = CSng(txtDutyCyc.Text)
		Thick = Thick / 25.4 ' convert millimeters to inches
		dVdB = CDbl(txtFrequency.Text) * 1000
		Ipri = CSng(txtPriCurrent.Text)
		N = CShort(txtRatio.Text)
		Conductor = CSng(txtCurDens.Text)
		CoreIDMin = N * Conductor
		' Load core data file
		ChDir((My.Application.Info.DirectoryPath))
		FileOpen(1, "Hall.txt", OpenMode.Input)
		For i = 1 To 26
			For j = 1 To 12
				Input(1, Core(i, j))
			Next j
		Next i
		FileClose(1)
		' First make sure that the requested material is considered
		If optFperm.Checked = True Then
			i = 1
		ElseIf optJperm.Checked = True Then 
			i = 9
		ElseIf optWperm.Checked = True Then 
			i = 17
		End If
		' Find smallest core to do the job
DoOver: 
		intSmall = 0
		Do While (Core(i, 8) < CoreIDMin)
            i = i + 1
        Loop
		If (Core(i, 8) = 999) Then
            intMsg = MsgBox("Required core is too large." & Chr(13) & "Try reducing conductor size, Hall Sensor thickness, or primary current.", CDbl(MsgBoxStyle.OkOnly & MsgBoxStyle.Critical), "Required Core Too Large")
            CoreIDMin = 999
        End If
		Select Case (intMsg)
			Case Is < 0
				Error(5)
			Case 1
				GoTo Output
		End Select
		' Calculate the necessary effective perm and gap
		Bmax = 10 ^ 6 * Vout / dVdB
		' Check to make sure core material can handle this flux density
		If (optFperm.Checked = True) And (Bmax > 6000) Then
			intMsg = MsgBox("Required flux density is too high for MPP material." & Chr(13) & "Try changing to Kool M" & Chr(181) & " material, or selecting a Hall Sensor with lower Vout.", MsgBoxStyle.OKOnly, "Bmax Too High")
		End If
		Select Case (intMsg)
			Case Is < 0
				Error(5)
			Case 1
				GoTo Output
		End Select
		If (optJperm.Checked = True) And (Bmax > 10000) Then
			intMsg = MsgBox("Required flux density is too high for Kool M" & Chr(181) & " material." & Chr(13) & "Try selecting a Hall Sensor with lower Vout.", MsgBoxStyle.OKOnly, "Bmax Too High")
		End If
		Select Case (intMsg)
			Case Is < 0
				Error(5)
			Case 1
				GoTo Output
		End Select
		If (optWperm.Checked = True) And (Bmax > 4000) Then
			intMsg = MsgBox("Required flux density is too high for ferrite material." & Chr(13) & "Try changing to Kool M" & Chr(181) & " or MPP material, or selecting a Hall Sensor with lower Vout.", MsgBoxStyle.OKOnly, "Bmax Too High")
		End If
		Select Case (intMsg)
			Case Is < 0
				Error(5)
			Case 1
				GoTo Output
		End Select
		le = Core(i, 6)
		EffPerm = (Bmax * le) / (0.4 * 3.14 * N * Ipri)
		CorePerm = Core(i, 7)
		Gap = le * ((1 / EffPerm) - (1 / CorePerm)) * 0.3937
		' Make sure that the Hall Sensor will fit in the gap
		If (Gap < Thick) Then Gap = Thick + 0.005
		' Make sure that gap is not larger than the core ID
		If (Gap > Core(i, 8)) Then
            intSmall = 1
            CoreIDMin = Gap
        End If
		Select Case (intSmall)
			Case Is < 0
				Error(5)
			Case 1
				GoTo DoOver
		End Select
		' Check to make sure that core is large enough to limit fringing effects
		If (Core(i, 4) < 2 * Gap) Or ((Core(i, 3) - Core(i, 2)) / 2 < 2 * Gap) Then
            i = i + 1
            intSmall = 1
        End If
		Select Case (intSmall)
			Case Is < 0
				Error(5)
			Case 1
				GoTo DoOver
		End Select
		
Output: 
		If (intMsg = 0) Then
            txtRequiredL.Text = VB6.Format(Gap, "0.000")
            txtWireSize.Text = VB6.Format(EffPerm, "##.0")
            txtCore.Text = Core(i, 1)
            Range = N * Ipri / Bmax
            txtActualL.Text = VB6.Format(Range, "#0.00")
            txtPartNum.Text = txtCore.Text
            txtID.Text = VB6.Format(Core(i, 2), "0.000")
            txtOD.Text = VB6.Format(Core(i, 3), "0.000")
            txtHt.Text = VB6.Format(Core(i, 4), "0.000")
            txtAe.Text = VB6.Format(Core(i, 5), "0.000")
            txtle.Text = VB6.Format(Core(i, 6), "##.00")
        Else
            txtRequiredL.Text = ""
            txtWireSize.Text = ""
            txtCore.Text = "N/A"
            txtActualL.Text = ""
            txtPartNum.Text = "N/A"
            txtID.Text = ""
            txtOD.Text = ""
            txtHt.Text = ""
            txtAL.Text = ""
            txtAe.Text = "N/A"
            txtle.Text = "N/A"
        End If
	End Sub
	
	Private Sub SMPS()
        Dim CoreL As Single
        Dim AL As Single
        Dim intWire As Integer
		' Call Error Routine to make sure all data entries are legitimate
        Dim intError As Integer
		Call ErrorSMPS(intError)
		On Error Resume Next
		' Declare needed variables
		Dim e As Single
		Dim duty As Single
		Dim f As Single
		Dim Ipri As Single
		Dim Isec As Single
		Dim N As Single
		Dim dT As Single
		Dim dI As Single
		Dim L As Single
		Dim AWG As Short
		Dim WireOD As Single
		Dim SecCurDens As Single
        Dim intNewDens As Integer
		Dim CoreIDMin As Single
		Dim Core(26, 14) As Object
        Dim i, j As Integer
        Dim intMsg As Integer
		Dim ALCol As Short
		Dim Perm As String
		Dim B As Single
		' Perform calculations that will govern core size
		intMsg = 0
		e = CSng(txtVoltage.Text)
		duty = CSng(txtDutyCyc.Text)
		f = CDbl(txtFrequency.Text) * 1000
		Ipri = CSng(txtPriCurrent.Text)
		N = CSng(txtRatio.Text)
		Isec = Ipri / N
		SecCurDens = CSng(txtCurDens.Text)
		dT = duty / f
		dI = 0.1 * Ipri / N
		L = 1000 * e * dT / dI
		AWG = -4.31 * System.Math.Log(1.889 * Isec / SecCurDens)
		If (AWG > 42) Then
			AWG = 42
		ElseIf (AWG < 12) Then 
			AWG = 12
			intNewDens = Isec / (6529 * 0.000005067)
			intWire = MsgBox("Required wire size is larger than any in current database." & Chr(13) & "Actual current density will be" & Chr(13) & intNewDens & " A/sq cm", MsgBoxStyle.OKOnly, "Wire Size Too Large")
		End If
		WireOD = WireDia(AWG)
		CoreIDMin = (1 + (N / 3.14)) * WireOD
		' Load core data file
		ChDir((My.Application.Info.DirectoryPath))
		FileOpen(1, "Ferrite.txt", OpenMode.Input)
		For i = 1 To 26
			For j = 1 To 14
				Input(1, Core(i, j))
			Next j
		Next i
		FileClose(1)
		' Find smallest core to do the job
		i = 1
		Do Until (Core(i, 10) > CoreIDMin)
            i = i + 1
        Loop
		If Core(i, 10) = 999 Then
            intMsg = MsgBox("Required core is too large." & Chr(13) & "Try reducing current or turns ratio.", CDbl(MsgBoxStyle.OkOnly & MsgBoxStyle.Critical), "Required Core Too Large")
            CoreIDMin = 999
        End If
		Select Case (intMsg)
			Case Is < 0
				Error(5)
			Case 1
				GoTo Output
		End Select
		' Verify core has high enough inductance
		' Determine what permeability has been selected first
        Perm = ""
        If (optFperm.Checked = True) Then
            Perm = "F"
            ALCol = 0
        ElseIf (optJperm.Checked = True) Then
            Perm = "J"
            ALCol = 1
        ElseIf (optWperm.Checked = True) Then
            Perm = "W"
            ALCol = 2
        End If
		' Now compare core AL against design expectations
		AL = Core(i, ALCol + 7)
		CoreL = AL * 10 ^ -6 * N ^ 2
		If (CoreL < L) Then
            Do Until (CoreL > L)
                i = i + 1
                AL = Core(i, ALCol + 7)
                CoreL = AL * 10 ^ -6 * N ^ 2
            Loop
        End If
		If Core(i, ALCol + 7) > 99998 Then
            intMsg = MsgBox("Required inductance is too large." & Chr(13) & "Try reducing voltage or increasing" & Chr(13) & "frequency or permeability.", CDbl(MsgBoxStyle.OkOnly & MsgBoxStyle.Critical), "Required L Too Large")
        End If
		Select Case (intMsg)
			Case Is < 0
				Error(5)
			Case 1
				GoTo Output
		End Select
		' Check to verify the core is not approaching saturation
		B = (e * 10 ^ 8) / (4 * Core(i, 5) * f * N)
		Select Case B
			Case B > 3300
				intMsg = MsgBox("Core is saturated.  Try " & Chr(13) & "reducing voltage or increasing" & Chr(13) & "turns ratio.", CDbl(MsgBoxStyle.OKOnly & MsgBoxStyle.Critical), "Core Saturation")
				AL = 99999
			Case B > 3000
				intMsg = MsgBox("Core is approaching saturation." & Chr(13) & "Increasing turns ratio or" & Chr(13) & "decreasing voltage could help." & Chr(13) & "B = " & B, MsgBoxStyle.OKOnly, "Approaching Saturation")
			Case Else
		End Select
Output: 
		' Route the output and core information to text boxes
		If (AL < 99999) And (Core(i, 10) < 999) Then
            txtRequiredL.Text = CStr(L)
            txtWireSize.Text = CStr(AWG)
            txtCore.Text = Core(i, 14) & Perm & "-" & Core(i, 1) & "-TC"
            txtActualL.Text = CoreL
            txtResID.Text = VB6.Format(Core(i, 10) - 2 * WireOD, "0.000")
            txtPartNum.Text = txtCore.Text
            txtID.Text = VB6.Format(Core(i, 2), "0.000")
            txtOD.Text = VB6.Format(Core(i, 3), "0.000")
            txtHt.Text = VB6.Format(Core(i, 4), "0.000")
            txtAL.Text = Core(i, ALCol + 7)
            txtAe.Text = Core(i, 5)
            txtle.Text = Core(i, 6)
        Else
            txtRequiredL.Text = ""
            txtWireSize.Text = ""
            txtCore.Text = "N/A"
            txtActualL.Text = ""
            txtResID.Text = ""
            txtPartNum.Text = "N/A"
            txtID.Text = ""
            txtOD.Text = ""
            txtHt.Text = ""
            txtAL.Text = ""
            txtAe.Text = "N/A"
            txtle.Text = "N/A"
        End If
	End Sub
	
	Private Sub TradCT()
        Dim Layer As Single
        Dim HtMax As Single
        Dim ODMax As Single
        Dim IDMin As Single
        Dim CoreIDMin As Single
        Dim dummy As Single
		' Call Error Routine to make sure all data entries are legitimate
		Dim intError As Short
		Call ErrorTradCT(intError)
		On Error Resume Next
		' Declare needed variables
		Dim Burden As Single
		Dim f As Single
		Dim Ipri As Single
		Dim Isec As Single
		Dim N As Single
		Dim AWG As Short
		Dim WireOD As Single
		Dim WireArea As Single
		Dim SecCurDens As Single
        Dim intNewDens As Integer
		Dim Core(47, 11) As Object
        Dim intMat, j, i, intMsg, intThick As Integer
        Dim intWire As Integer
		Dim CoreLoss As Single
		Dim CopperLoss As Single
		Dim TotalLoss As Single
		Dim Accuracy As Single
		Dim Bmax As Single
		Dim B As Single
		Dim Area As Single
		Dim Vsec As Single
		Dim AreaMult As Single
		Dim CoreArea As Single
		Dim Window As Single
		Dim Ve As Single
		Dim K As Single ' Note that this is a core material density constant, not winding factor
		Dim WindFactor As Single
		Dim MLT As Single
		' Dim DCR As Single
		Dim MatCode As String
        MatCode = ""
        intMsg = 0
		' Determine what material and thickness were selected, and verify proper flux selection
		If (optFperm.Checked = True) Then
			intMat = 1
			K = 0.0169
			MatCode = "K"
			Do While (IsNumeric(txtDutyCyc.Text) = False)
				dummy = InputBox("Bmax field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for the Flux Densiity.", "Invalid Entry", "15000")
				txtDutyCyc.Text = dummy
			Loop 
			Do While (txtDutyCyc.Text <= CStr(0.99)) Or (CDbl(txtDutyCyc.Text) > 15000)
				dummy = InputBox("Magnesil Bmax must be between 1G 15000G." & Chr(13) & Chr(13) & "Please enter a new value for Bmax.", "Invalid Entry", "15000")
				txtDutyCyc.Text = dummy
			Loop 
		ElseIf (optJperm.Checked = True) Then 
			intMat = 2
			K = 0.0181
			MatCode = "H"
			Do While (IsNumeric(txtDutyCyc.Text) = False)
				dummy = InputBox("Bmax field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for the Flux Densiity.", "Invalid Entry", "10000")
				txtDutyCyc.Text = dummy
			Loop 
			Do While (txtDutyCyc.Text <= CStr(0.99)) Or (CDbl(txtDutyCyc.Text) > 11500)
				dummy = InputBox("48 Alloy Bmax must be between 1G 11500G." & Chr(13) & Chr(13) & "Please enter a new value for Bmax.", "Invalid Entry", "10000")
				txtDutyCyc.Text = dummy
			Loop 
		ElseIf (optWperm.Checked = True) Then 
			intMat = 3
			K = 0.0192
			MatCode = "F"
			Do While (IsNumeric(txtDutyCyc.Text) = False)
				dummy = InputBox("Bmax field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for the Flux Densiity.", "Invalid Entry", "5000")
				txtDutyCyc.Text = dummy
			Loop 
			Do While (txtDutyCyc.Text <= CStr(0.99)) Or (CDbl(txtDutyCyc.Text) > 6000)
				dummy = InputBox("Supermalloy Bmax must be between 1G and 6000G." & Chr(13) & Chr(13) & "Please enter a new value for Bmax.", "Invalid Entry", "5000")
				txtDutyCyc.Text = dummy
			Loop 
		End If
		If (opt1mil.Checked = True) Then
			intThick = 1
			AreaMult = 0.88
		ElseIf (opt2mil.Checked = True) Then 
			intThick = 2
			AreaMult = 1
		ElseIf (opt4mil.Checked = True) Then 
			intThick = 4
			AreaMult = 1.06
		End If
		' Calculate what core area and window are needed
		Burden = CSng(txtVoltage.Text)
		f = CSng(txtFrequency.Text)
		Ipri = CSng(txtPriCurrent.Text)
		Bmax = CSng(txtDutyCyc.Text)
		N = CSng(txtRatio.Text)
		SecCurDens = CSng(txtCurDens.Text)
		Isec = Ipri / N
		Vsec = Burden * Isec
		Area = (Vsec * 10 ^ 8) / (4.44 * Bmax * f * N)
		CoreArea = Area / AreaMult
		' Assume winding factor of 0.2 for secondary windings
		' First must determine wire size
		AWG = -4.31 * System.Math.Log(1.889 * Isec / SecCurDens)
		If (AWG > 42) Then
			AWG = 42
		ElseIf (AWG < 12) Then 
			AWG = 12
			intNewDens = Isec / (6529 * 0.000005067)
			intWire = MsgBox("Required wire size is larger than any in current database." & Chr(13) & "Actual current density will be" & Chr(13) & intNewDens & " A/sq cm", MsgBoxStyle.OKOnly, "Wire Size Too Large")
		End If
		WireOD = WireDia(AWG)
		WireArea = 3.14 * (WireOD * 2.54 / 2) ^ 2 'Calculates wire cross section in sq cm
		Window = N * WireArea / 0.2
		' Load core data file
		ChDir((My.Application.Info.DirectoryPath))
		FileOpen(1, "TWC.txt", OpenMode.Input)
		For i = 1 To 47
			For j = 1 To 11
				Input(1, Core(i, j))
			Next j
		Next i
		FileClose(1)
		' Now go find the right core size
		' First make sure that core area is large enough
		i = 1
		Do Until (Core(i, 5) > CoreArea)
            i = i + 1
        Loop
		If (Core(i, 5) = 999999) Then
            intMsg = MsgBox("Required core area is too large." & Chr(13) & "Try reducing the burden or increasing Bmax.", CDbl(MsgBoxStyle.OkOnly & MsgBoxStyle.Critical), "Required Core Too Large")
            CoreIDMin = 999
        End If
		Select Case (intMsg)
			Case Is < 0
				Error(5)
			Case 1
				GoTo Output
		End Select
		' Next make sure window is big enough
		If (Core(i, 11) < Window) Then
            Do Until (Core(i, 11) > Window)
                i = i + 1
            Loop
        End If
		If (Core(i, 11) = 9999) Then
            intMsg = MsgBox("Required core window is too large." & Chr(13) & "Try reducing turns ratio or increasing current density.", CDbl(MsgBoxStyle.OkOnly & MsgBoxStyle.Critical), "Required Core Large")
        End If
		Select Case (intMsg)
			Case Is < 0
				Error(5)
			Case 1
				GoTo Output
		End Select
		'Verify that core part number is valid (i.e., no small 4 mil parts)
		If (Core(i, 7) = "N") And (intThick = 4) Then
            opt2mil.Checked = True
            intThick = 2
            AreaMult = 1
            dummy = MsgBox("Core selected is not available in 4 mil material thickness." & Chr(13) & "A 2 mil thickness variant has been chosen instead.", MsgBoxStyle.OkOnly, "4 mil Not Available")
        End If
		' Now calculate losses and accuracy
		' Core loss first
		Area = Core(i, 5) * AreaMult
		B = (Vsec * 10 ^ 4) / (4.44 * Area * f * N) ' Flux here is in Tesla, not Gauss
		Ve = Area * Core(i, 6)
		If (intMat = 1) Then
            If (intThick = 2) Then
                CoreLoss = 0.012 * (f ^ 1.03) * (B ^ 1.6) * Ve * K
            ElseIf (intThick = 4) Then
                CoreLoss = 0.00204 * (f ^ 1.3) * (B ^ 2.01) * Ve * K
            End If
        ElseIf (intMat = 2) Then
            If (intThick = 2) Then
                CoreLoss = 0.00010151 * (f ^ 1.4789) * (B ^ 1.6018) * Ve * K
            ElseIf (intThick = 4) Then
                CoreLoss = 0.000281 * (f ^ 1.57) * (B ^ 1.95) * Ve * K
            End If
        ElseIf (intMat = 3) Then
            If (intThick = 1) Then
                CoreLoss = 0.000111684 * (f ^ 1.35) * (B ^ 1.91) * Ve * K
            ElseIf (intThick = 2) Then
                CoreLoss = 0.000081266 * (f ^ 1.48) * (B ^ 2.15) * Ve * K
            End If
        End If
		' Now Copper Losses
		WindFactor = N * WireArea / Core(i, 11)
		' DCR = WireDia(AWG)  ' Returns Ohms per 1000 feet
		Dim TotalLength As Single
		Dim Nprime As Short
		Dim ResID As Single
		IDMin = Core(i, 8)
		ODMax = Core(i, 9)
		HtMax = Core(i, 10)
		TotalLength = 0
		Nprime = N
		' Calculate the mean length of turn
		Do While (Nprime > 0)
			Layer = Int(3.14 * (IDMin - WireOD) / WireOD)
			If (Layer > Nprime) Then
                Layer = Nprime
            End If
			TotalLength = TotalLength + Layer * ((ODMax - IDMin) + (2 * HtMax))
			Nprime = Nprime - Layer
			IDMin = IDMin - 2 * WireOD
			ODMax = ODMax + 2 * WireOD
			HtMax = HtMax + 2 * WireOD
		Loop 
		MLT = TotalLength / N
		ResID = IDMin
		CopperLoss = (N * MLT / 12000) * DCR * Isec ^ 2
		' Now Total Losses and Accuracy
		TotalLoss = (CoreLoss + CopperLoss) * 1000
		Accuracy = (100 * CoreLoss * N) / Ipri
		
		' Route the output and core information to text boxes
Output: 
		If (intMsg = 0) Then
            txtRequiredL.Text = VB6.Format(Accuracy, "0.00") & "%"
            txtWireSize.Text = CStr(AWG)
            txtCore.Text = Core(i, 1) & "-" & intThick & MatCode
            txtActualL.Text = VB6.Format(TotalLoss, "###,###,##0.###")
            txtResID.Text = VB6.Format(ResID, "0.000")
            txtPartNum.Text = txtCore.Text
            txtID.Text = VB6.Format(Core(i, 2), "0.000")
            txtOD.Text = VB6.Format(Core(i, 3), "0.000")
            txtHt.Text = VB6.Format(Core(i, 4), "0.000")
            txtAe.Text = VB6.Format(Area, "0.000")
            txtle.Text = VB6.Format(Core(i, 6), "##.00")
        Else
            txtRequiredL.Text = ""
            txtWireSize.Text = ""
            txtCore.Text = "N/A"
            txtActualL.Text = ""
            txtResID.Text = ""
            txtPartNum.Text = "N/A"
            txtID.Text = ""
            txtOD.Text = ""
            txtHt.Text = ""
            txtAL.Text = ""
            txtAe.Text = "N/A"
            txtle.Text = "N/A"
        End If
	End Sub
	
    Private Sub ErrorTradCT(ByRef intError As Integer)
        Dim dummy As Single
        intError = 0
        Do While (IsNumeric(txtVoltage.Text) = False)
            dummy = InputBox("Burden Resistance field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for Burden Resistance.", "Invalid Entry", "5")
            txtVoltage.Text = dummy
        Loop
        Do While (CDbl(txtVoltage.Text) <= 0)
            dummy = InputBox("Burden Resistance field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for Burden Resistance.", "Invalid Entry", "5")
            txtVoltage.Text = dummy
        Loop
        Do While (IsNumeric(txtFrequency.Text) = False)
            dummy = InputBox("Frequency field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a new value for Frequency.", "Invalid Entry", "60")
            txtFrequency.Text = dummy
        Loop
        Do While (CDbl(txtFrequency.Text) <= 0)
            dummy = InputBox("Frequency field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a new value for Frequency.", "Invalid Entry", "60")
            txtFrequency.Text = dummy
        Loop
        Do While (IsNumeric(txtPriCurrent.Text) = False)
            dummy = InputBox("Current field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a new value for the Primary Current.", "Invalid Entry", "10")
            txtPriCurrent.Text = dummy
        Loop
        Do While (CDbl(txtPriCurrent.Text) <= 0)
            dummy = InputBox("Current field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a new value for the Primary Current.", "Invalid Entry", "10")
            txtPriCurrent.Text = dummy
        Loop
        Do While (IsNumeric(txtRatio.Text) = False)
            dummy = InputBox("Turns Ratio field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for the Turns Ratio.", "Invalid Entry", "100")
            txtRatio.Text = dummy
        Loop
        Do While (CDbl(txtRatio.Text) <= 0)
            dummy = InputBox("Turns Ratio field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for the Turns Ratio.", "Invalid Entry", "100")
            txtRatio.Text = dummy
        Loop
        Do While (IsNumeric(txtCurDens.Text) = False)
            dummy = InputBox("Current Density field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for Current Density.", "Invalid Entry", "400")
            txtCurDens.Text = dummy
        Loop
        Do While (CDbl(txtCurDens.Text) <= 0)
            dummy = InputBox("Current Density field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for Current Density.", "Invalid Entry", "400")
            txtCurDens.Text = dummy
        Loop
    End Sub
    Private Sub ErrorHall(ByRef intError As Integer)
        Dim dummy As Single
        intError = 0
        Do While (IsNumeric(txtVoltage.Text) = False)
            dummy = InputBox("Sensor output field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for sensor output.", "Invalid Entry", "2")
            txtVoltage.Text = dummy
        Loop
        Do While (CDbl(txtVoltage.Text) <= 0)
            dummy = InputBox("Sensor output field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for sensor output.", "Invalid Entry", "2")
            txtVoltage.Text = dummy
        Loop
        Do While (IsNumeric(txtFrequency.Text) = False)
            dummy = InputBox("Sensitivity field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a new value for sensitivity.", "Invalid Entry", "10")
            txtFrequency.Text = dummy
        Loop
        Do While (CDbl(txtFrequency.Text) <= 0)
            dummy = InputBox("Sensitivity field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a new value for sensitivity.", "Invalid Entry", "10")
            txtFrequency.Text = dummy
        Loop
        Do While (IsNumeric(txtPriCurrent.Text) = False)
            dummy = InputBox("Current field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a new value for the primary current.", "Invalid Entry", "100")
            txtPriCurrent.Text = dummy
        Loop
        Do While (CDbl(txtPriCurrent.Text) <= 0)
            dummy = InputBox("Current field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a new value for the primary current.", "Invalid Entry", "100")
            txtPriCurrent.Text = dummy
        Loop
        Do While (IsNumeric(txtRatio.Text) = False)
            dummy = InputBox("Primary turns field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for primary turns.", "Invalid Entry", "1")
            txtRatio.Text = dummy
        Loop
        Do While (CDbl(txtRatio.Text) <= 0)
            dummy = InputBox("Primary turns field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for primary turns.", "Invalid Entry", "1")
            txtRatio.Text = dummy
        Loop
        Do While (IsNumeric(txtCurDens.Text) = False)
            dummy = InputBox("Conductor size field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for conductor size.", "Invalid Entry", VB6.Format(0.1, "0.000"))
            txtCurDens.Text = dummy
        Loop
        Do While (CDbl(txtCurDens.Text) <= 0)
            dummy = InputBox("Conductor Size field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for conductor size.", "Invalid Entry", VB6.Format(0.1, "0.000"))
            txtCurDens.Text = dummy
        Loop
        Do While (IsNumeric(txtDutyCyc.Text) = False)
            dummy = InputBox("Sensor thickness field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for sensor thickness.", "Invalid Entry", ".5")
            txtDutyCyc.Text = dummy
        Loop
        Do While (CDbl(txtDutyCyc.Text) <= 0)
            dummy = InputBox("Sensor thickness field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for sensor thickness.", "Invalid Entry", ".5")
            txtDutyCyc.Text = dummy
        Loop
    End Sub
    Private Sub ErrorSMPS(ByRef intError As Integer)
        Dim dummy As Single
        intError = 0
        Do While (IsNumeric(txtVoltage.Text) = False)
            dummy = InputBox("Voltage field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for Output Voltage.", "Invalid Entry", "0.5")
            txtVoltage.Text = dummy
        Loop
        Do While (IsNumeric(txtFrequency.Text) = False)
            dummy = InputBox("Frequency field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a new value for Frequency.", "Invalid Entry", "50")
            txtFrequency.Text = dummy
        Loop
        Do While (CDbl(txtFrequency.Text) <= 0)
            dummy = InputBox("Frequency field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a new value for Frequency.", "Invalid Entry", "50")
            txtFrequency.Text = dummy
        Loop
        Do While (IsNumeric(txtPriCurrent.Text) = False)
            dummy = InputBox("Current field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a new value for the Primary Current.", "Invalid Entry", "10")
            txtPriCurrent.Text = dummy
        Loop
        Do While (CDbl(txtPriCurrent.Text) <= 0)
            dummy = InputBox("Current field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a new value for the Primary Current.", "Invalid Entry", "10")
            txtPriCurrent.Text = dummy
        Loop
        Do While (IsNumeric(txtDutyCyc.Text) = False)
            dummy = InputBox("Duty Cycle field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for the Duty Cycle.", "Invalid Entry", "0.5")
            txtDutyCyc.Text = dummy
        Loop
        Do While (IsNumeric(txtRatio.Text) = False)
            dummy = InputBox("Turns Ratio field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for the Turns Ratio.", "Invalid Entry", "100")
            txtRatio.Text = dummy
        Loop
        Do While (CDbl(txtRatio.Text) <= 0)
            dummy = InputBox("Turns Ratio field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for the Turns Ratio.", "Invalid Entry", "100")
            txtRatio.Text = dummy
        Loop
        Do While (IsNumeric(txtCurDens.Text) = False)
            dummy = InputBox("Current Density field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for Current Density.", "Invalid Entry", "400")
            txtCurDens.Text = dummy
        Loop
        Do While (CDbl(txtCurDens.Text) <= 0)
            dummy = InputBox("Current Density field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for Current Density.", "Invalid Entry", "400")
            txtCurDens.Text = dummy
        Loop
    End Sub
	
	Private Sub cmdCalculate_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdCalculate.Click
		If optSMPS.Checked = True Then
			Call SMPS()
		ElseIf optTradCT.Checked = True Then 
			Call TradCT()
		ElseIf optHall.Checked = True Then 
			Call Hall()
		End If
	End Sub
	
    Public Function WireDia(ByRef AWG As Single) As Single
        ' Dim DCR As Single
        Dim Wire(43, 3) As Object
        ' Wire (x, 1) is circular mils of cross section
        ' Wire (x, 2) is wire OD in inches
        ' Wire (x, 3) is Ohms per 1000 feet
        Wire(12, 2) = 0.0847
        Wire(12, 1) = 6529
        Wire(12, 3) = 1.589
        Wire(13, 2) = 0.0757
        Wire(13, 1) = 5184
        Wire(13, 3) = 2.001
        Wire(14, 2) = 0.0682
        Wire(14, 1) = 4109
        Wire(14, 3) = 2.524
        Wire(15, 2) = 0.0609
        Wire(15, 1) = 3260
        Wire(15, 3) = 3.181
        Wire(16, 2) = 0.0545
        Wire(16, 1) = 2581
        Wire(16, 3) = 4.019
        Wire(17, 2) = 0.0488
        Wire(17, 1) = 2052
        Wire(17, 3) = 5.054
        Wire(18, 1) = 1624
        Wire(18, 2) = 0.0437
        Wire(18, 3) = 6.386
        Wire(19, 1) = 1289
        Wire(19, 2) = 0.0391
        Wire(19, 3) = 8.047
        Wire(20, 1) = 1024
        Wire(20, 2) = 0.0351
        Wire(20, 3) = 10.13
        Wire(21, 1) = 812.3
        Wire(21, 2) = 0.0314
        Wire(21, 3) = 12.77
        Wire(22, 1) = 640.1
        Wire(22, 2) = 0.0281
        Wire(22, 3) = 16.2
        Wire(23, 1) = 510.8
        Wire(23, 2) = 0.0253
        Wire(23, 3) = 20.31
        Wire(24, 1) = 404
        Wire(24, 2) = 0.0227
        Wire(24, 3) = 25.67
        Wire(25, 1) = 320.4
        Wire(25, 2) = 0.0203
        Wire(25, 3) = 32.37
        Wire(26, 1) = 252.8
        Wire(26, 2) = 0.0182
        Wire(26, 3) = 41.02
        Wire(27, 1) = 201.6
        Wire(27, 2) = 0.0164
        Wire(27, 3) = 51.43
        Wire(28, 1) = 158.8
        Wire(28, 2) = 0.0147
        Wire(28, 3) = 65.33
        Wire(29, 1) = 127.7
        Wire(29, 2) = 0.0133
        Wire(29, 3) = 81.22
        Wire(30, 1) = 100
        Wire(30, 2) = 0.0119
        Wire(30, 3) = 103.7
        Wire(31, 1) = 79.21
        Wire(31, 2) = 0.0108
        Wire(31, 3) = 130.9
        Wire(32, 1) = 64
        Wire(32, 2) = 0.0098
        Wire(32, 3) = 162
        Wire(33, 1) = 50.41
        Wire(33, 2) = 0.0088
        Wire(33, 3) = 205.7
        Wire(34, 1) = 39.69
        Wire(34, 2) = 0.0078
        Wire(34, 3) = 261.3
        Wire(35, 1) = 31.36
        Wire(35, 2) = 0.007
        Wire(35, 3) = 330.7
        Wire(36, 1) = 25
        Wire(36, 2) = 0.0063
        Wire(36, 3) = 414.8
        Wire(37, 1) = 20.25
        Wire(37, 2) = 0.0057
        Wire(37, 3) = 512.1
        Wire(38, 1) = 16
        Wire(38, 2) = 0.0051
        Wire(38, 3) = 648.2
        Wire(39, 1) = 12.25
        Wire(39, 2) = 0.0045
        Wire(39, 3) = 846.6
        Wire(40, 1) = 9.61
        Wire(40, 2) = 0.004
        Wire(40, 3) = 1079
        Wire(41, 1) = 7.84
        Wire(41, 2) = 0.0036
        Wire(41, 3) = 1423
        Wire(42, 1) = 6.25
        Wire(42, 2) = 0.0032
        Wire(42, 3) = 1659
        WireDia = Wire(AWG, 2)
        DCR = Wire(AWG, 3)
    End Function
	
	Private Sub cmdExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdExit.Click
		Me.Close()
	End Sub
	
	Private Sub cmdPrint_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdPrint.Click
		Call mnuPrint_Click(mnuPrint, New System.EventArgs())
    End Sub

    Private Sub frmCTDesign_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Dim intDisclaimer As Integer
        ' Show Disclaimer before design can begin
        intDisclaimer = MsgBox("Designs generated by this software are believed to be accurate.  However, MAGNETICS will not be held liable for any errors in judgement made by the operator or for the design achieved.  The design parameters, core size calculations, wire size calculations, and all other information are a function of the circuitry under consideration.  Any further design questions should be directed to:" & Chr(13) & Chr(13) & "The MAGNETICS Applications Engineering Group at:  (412) 696-1333", MsgBoxStyle.OkOnly, "***MAGNETICS Disclaimer***")
    End Sub
	
	Public Sub mnuAbout_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuAbout.Click
        Dim intAbout As Integer
        intAbout = MsgBox("Magnetics Current Transformer Design Software." & Chr(13) & Chr(13) & "Version 2.0, 2009, WEG", MsgBoxStyle.OkOnly, "About CT Design")
	End Sub
	
	Public Sub mnuContact_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuContact.Click
        Dim intContact As Integer
        intContact = MsgBox("Contact MAGNETICS Applications Engineering and Sales at:" & Chr(13) & Chr(13) & "Phone: (412) 696-1333" & Chr(13) & "Fax:     412-696-0333" & Chr(13) & "Email: magnetics@spang.com", MsgBoxStyle.OkOnly)
	End Sub
	
	Public Sub mnuContents_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuContents.Click
        Help.ShowHelp(Me, Application.StartupPath & "\CT.chm")
	End Sub
	
	Public Sub mnuExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuExit.Click
		Me.Close()
	End Sub
	
	Public Sub mnuIndex_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuIndex.Click
        Help.ShowHelpIndex(Me, Application.StartupPath & "\CT.chm")
	End Sub
	
	Public Sub mnuOpen_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuOpen.Click
        Dim duty As Single
        Dim e As Single
        Dim Conductor As Single
        Dim Thick As Single
        Dim dVdB As Single
        Dim Vout As Single
        Dim SecCurDens As Single
        Dim N As Single
        Dim Bmax As Single
        Dim Ipri As Single
        Dim f As Single
        Dim Burden As Single
        Dim intOpen As Integer
        Dim intMatType As Integer
        Dim intThickness As Integer
		' CancelError is True.
		On Error GoTo ErrHandler
		' Set filters.
		cmnDialog1Open.Filter = "All Files (*.*)|*.*|Trad CT Files (*.tct)|*.tct|Hall Effect Files (*.hef)|*.hef|SMPS Files (*.sps)|*.sps"
		cmnDialog1Save.Filter = "All Files (*.*)|*.*|Trad CT Files (*.tct)|*.tct|Hall Effect Files (*.hef)|*.hef|SMPS Files (*.sps)|*.sps"
		' Specify default filter.
		If optTradCT.Checked = True Then
			intOpen = 2
		ElseIf optHall.Checked = True Then 
			intOpen = 3
		ElseIf optSMPS.Checked = True Then 
			intOpen = 4
		End If
		cmnDialog1Open.FilterIndex = intOpen
		cmnDialog1Save.FilterIndex = intOpen
		
		' Display the Open dialog box.
		cmnDialog1Open.ShowDialog()
		cmnDialog1Save.FileName = cmnDialog1Open.FileName
		' Call the open file procedure.
		FileOpen(2, (cmnDialog1Open.FileName), OpenMode.Input)
		' Write the relavent variable data to the right text boxes
		Input(2, intOpen)
		Select Case intOpen
			Case 2
				optTradCT.Checked = True
				Input(2, Burden)
				txtVoltage.Text = Burden
				Input(2, f)
				txtFrequency.Text = f
				Input(2, Ipri)
				txtPriCurrent.Text = Ipri
				Input(2, Bmax)
				txtDutyCyc.Text = Bmax
				Input(2, N)
				txtRatio.Text = N
				Input(2, SecCurDens)
				txtCurDens.Text = SecCurDens
				Input(2, intMatType)
				Select Case intMatType
					Case 1
						optFperm.Checked = True
					Case 2
						optJperm.Checked = True
					Case 3
						optWperm.Checked = True
				End Select
				Input(2, intThickness)
				Select Case intThickness
					Case 1
						opt1mil.Checked = True
					Case 2
						opt2mil.Checked = True
					Case 4
						opt4mil.Checked = True
				End Select
			Case 3
				optHall.Checked = True
				Input(2, Vout)
				txtVoltage.Text = Vout
				Input(2, dVdB)
				txtFrequency.Text = dVdB
				Input(2, Ipri)
				txtPriCurrent.Text = Ipri
				Input(2, Thick)
				txtDutyCyc.Text = Thick
				Input(2, N)
				txtRatio.Text = N
				Input(2, Conductor)
				txtCurDens.Text = Conductor
				Input(2, intMatType)
				Select Case intMatType
					Case 1
						optFperm.Checked = True
					Case 2
						optJperm.Checked = True
					Case 3
						optWperm.Checked = True
				End Select
			Case 4
				optSMPS.Checked = True
				Input(2, e)
				txtVoltage.Text = e
				Input(2, f)
				txtFrequency.Text = f
				Input(2, Ipri)
				txtPriCurrent.Text = Ipri
				Input(2, duty)
				txtDutyCyc.Text = duty
				Input(2, N)
				txtRatio.Text = N
				Input(2, SecCurDens)
				txtCurDens.Text = SecCurDens
				Input(2, intMatType)
				Select Case intMatType
					Case 1
						optFperm.Checked = True
					Case 2
						optJperm.Checked = True
					Case 3
						optWperm.Checked = True
				End Select
		End Select
		' Close file so that this file number is free for other Open/Save functions
		FileClose(2)
		Call cmdCalculate_Click(cmdCalculate, New System.EventArgs())
		Exit Sub
		
ErrHandler: 
		' User pressed Cancel button.
		Exit Sub
	End Sub
	
    Private WithEvents DocToPrint As New Printing.PrintDocument

    Private Sub DocToPrint_PrintPage(ByVal Sender As Object _
    , ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles DocToPrint.PrintPage
        Dim fontbold As New System.Drawing.Font("Arial", 10, FontStyle.Bold)
        Dim font As New System.Drawing.Font("Arial", 10)

        If optTradCT.Checked = True Then
            e.Graphics.DrawString("Traditional Current Transformer Design   " & DateString, fontbold, Brushes.Black, 120, 120)
            e.Graphics.DrawString("   Part Number:", font, Brushes.Black, 120, 180)
            e.Graphics.DrawString(txtPartNum.Text, font, Brushes.Black, 295, 180)
            e.Graphics.DrawString("   Secondary Turns:", font, Brushes.Black, 120, 200)
            e.Graphics.DrawString(txtRatio.Text, font, Brushes.Black, 295, 200)
            e.Graphics.DrawString("   Wire Size:", font, Brushes.Black, 120, 220)
            e.Graphics.DrawString("#" & txtWireSize.Text & " AWG", font, Brushes.Black, 295, 220)
            e.Graphics.DrawString("   Residual ID:", font, Brushes.Black, 120, 240)
            e.Graphics.DrawString(txtResID.Text & " inches", font, Brushes.Black, 295, 240)
            e.Graphics.DrawString("   Accuracy:", font, Brushes.Black, 120, 260)
            e.Graphics.DrawString(txtRequiredL.Text, font, Brushes.Black, 295, 260)
            e.Graphics.DrawString("Core parameters", fontbold, Brushes.Black, 120, 300)
            e.Graphics.DrawString("   ID:", font, Brushes.Black, 120, 340)
            e.Graphics.DrawString(VB6.Format(txtID.Text, "0.000") & " inches (bare, nominal)", font, Brushes.Black, 295, 340)
            e.Graphics.DrawString("   OD:", font, Brushes.Black, 120, 360)
            e.Graphics.DrawString(VB6.Format(txtOD.Text, "0.000") & " inches (bare, nominal)", font, Brushes.Black, 295, 360)
            e.Graphics.DrawString("   Ht:", font, Brushes.Black, 120, 380)
            e.Graphics.DrawString(VB6.Format(txtHt.Text, "0.000") & " inches (bare, nominal)", font, Brushes.Black, 295, 380)
            e.Graphics.DrawString("   Core Area:", font, Brushes.Black, 120, 400)
            e.Graphics.DrawString(txtAe.Text & " sq cm", font, Brushes.Black, 295, 400)
            e.Graphics.DrawString("   Path Length:", font, Brushes.Black, 120, 420)
            e.Graphics.DrawString(txtle.Text & " cm", font, Brushes.Black, 295, 420)
        ElseIf optHall.Checked = True Then
            e.Graphics.DrawString("Hall Effect Current Transformer Design   " & DateString, fontbold, Brushes.Black, 120, 120)
            e.Graphics.DrawString("   Part Number:", font, Brushes.Black, 120, 180)
            e.Graphics.DrawString(txtPartNum.Text, font, Brushes.Black, 295, 180)
            e.Graphics.DrawString("   Gap Length:", font, Brushes.Black, 120, 200)
            e.Graphics.DrawString(txtRequiredL.Text & " inches", font, Brushes.Black, 295, 200)
            e.Graphics.DrawString("   Effective Permeability:", font, Brushes.Black, 120, 220)
            e.Graphics.DrawString(txtWireSize.Text, font, Brushes.Black, 295, 220)
            e.Graphics.DrawString("   Sensitivity Range (A*T/G):", font, Brushes.Black, 120, 240)
            e.Graphics.DrawString(txtActualL.Text, font, Brushes.Black, 295, 240)
            e.Graphics.DrawString("Core parameters", fontbold, Brushes.Black, 120, 280)
            e.Graphics.DrawString("   ID:", font, Brushes.Black, 120, 320)
            e.Graphics.DrawString(VB6.Format(txtID.Text, "0.000") & " inches (nominal)", font, Brushes.Black, 295, 320)
            e.Graphics.DrawString("   OD:", font, Brushes.Black, 120, 340)
            e.Graphics.DrawString(VB6.Format(txtOD.Text, "0.000") & " inches (nominal)", font, Brushes.Black, 295, 340)
            e.Graphics.DrawString("   Ht:", font, Brushes.Black, 120, 360)
            e.Graphics.DrawString(VB6.Format(txtHt.Text, "0.000") & " inches (nominal)", font, Brushes.Black, 295, 360)
            e.Graphics.DrawString("   Core Area:", font, Brushes.Black, 120, 380)
            e.Graphics.DrawString(txtAe.Text & " sq cm", font, Brushes.Black, 295, 380)
            e.Graphics.DrawString("   Path Length:", font, Brushes.Black, 120, 400)
            e.Graphics.DrawString(txtle.Text & " cm", font, Brushes.Black, 295, 400)
        ElseIf optSMPS.Checked = True Then
            e.Graphics.DrawString("SMPS Current Transformer Design   " & DateString, fontbold, Brushes.Black, 120, 120)
            e.Graphics.DrawString("   Part Number:", font, Brushes.Black, 120, 180)
            e.Graphics.DrawString(txtPartNum.Text, font, Brushes.Black, 295, 180)
            e.Graphics.DrawString("   Secondary Turns:", font, Brushes.Black, 120, 200)
            e.Graphics.DrawString(txtRatio.Text, font, Brushes.Black, 295, 200)
            e.Graphics.DrawString("   Wire Size:", font, Brushes.Black, 120, 220)
            e.Graphics.DrawString("#" & txtWireSize.Text & " AWG", font, Brushes.Black, 295, 220)
            e.Graphics.DrawString("   Residual ID:", font, Brushes.Black, 120, 240)
            e.Graphics.DrawString(txtResID.Text & " inches", font, Brushes.Black, 295, 240)
            e.Graphics.DrawString("Core parameters", fontbold, Brushes.Black, 120, 280)
            e.Graphics.DrawString("   ID:", font, Brushes.Black, 120, 320)
            e.Graphics.DrawString(VB6.Format(txtID.Text, "0.000") & " inches (nominal)", font, Brushes.Black, 295, 320)
            e.Graphics.DrawString("   OD:", font, Brushes.Black, 120, 340)
            e.Graphics.DrawString(VB6.Format(txtOD.Text, "0.000") & " inches (nominal)", font, Brushes.Black, 295, 340)
            e.Graphics.DrawString("   Ht:", font, Brushes.Black, 120, 360)
            e.Graphics.DrawString(VB6.Format(txtHt.Text, "0.000") & " inches (nominal)", font, Brushes.Black, 295, 360)
            e.Graphics.DrawString("   Core Area:", font, Brushes.Black, 120, 380)
            e.Graphics.DrawString(txtAe.Text & " sq cm", font, Brushes.Black, 295, 380)
            e.Graphics.DrawString("   Path Length:", font, Brushes.Black, 120, 400)
            e.Graphics.DrawString(txtle.Text & " cm", font, Brushes.Black, 295, 400)
            e.Graphics.DrawString("   AL:", font, Brushes.Black, 120, 420)
            e.Graphics.DrawString(txtAL.Text & " mH/1000T, nom", font, Brushes.Black, 295, 420)
        End If
    End Sub
    Public Sub mnuPrint_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuPrint.Click
        Dim PrintDialog1 As New PrintDialog
        If PrintDialog1.ShowDialog = 1 Then
            DocToPrint.PrinterSettings = PrintDialog1.PrinterSettings
            DocToPrint.Print()
        End If
    End Sub
	
	Public Sub mnuSaveAs_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuSaveAs.Click
        Dim intOpen As Integer
		Dim strFilename As String
		Dim intMatType As Short
		Dim intThickness As Short
		Dim intFileSave As Short
		intFileSave = 0
		' CancelError is True.
		On Error GoTo ErrHandler
		' Set filters.
		cmnDialog1Open.Filter = "All Files (*.*)|*.*|Trad CT Files (*.tct)|*.tct|Hall Effect Files (*.hef)|*.hef|SMPS Files (*.sps)|*.sps"
		cmnDialog1Save.Filter = "All Files (*.*)|*.*|Trad CT Files (*.tct)|*.tct|Hall Effect Files (*.hef)|*.hef|SMPS Files (*.sps)|*.sps"
		' Specify default filter.
		If optTradCT.Checked = True Then
			intOpen = 2
			cmnDialog1Open.DefaultExt = ".tct"
			cmnDialog1Save.DefaultExt = ".tct"
		ElseIf optHall.Checked = True Then 
			intOpen = 3
			cmnDialog1Open.DefaultExt = ".hef"
			cmnDialog1Save.DefaultExt = ".hef"
		ElseIf optSMPS.Checked = True Then 
			intOpen = 4
			cmnDialog1Open.DefaultExt = ".sps"
			cmnDialog1Save.DefaultExt = ".sps"
		End If
		cmnDialog1Open.FilterIndex = intOpen
		cmnDialog1Save.FilterIndex = intOpen
		' Display the Save As dialog box.
        'cmnDialog1.Flags = &H6
		cmnDialog1Save.ShowDialog()
		cmnDialog1Open.FileName = cmnDialog1Save.FileName
		' Call the save file procedure.
		FileOpen(2, (cmnDialog1Open.FileName), OpenMode.Output)
		' Write the relavent variable data to the right text boxes
		WriteLine(2, intOpen)
		Select Case intOpen
			Case 2
				WriteLine(2, txtVoltage.Text)
				WriteLine(2, txtFrequency.Text)
				WriteLine(2, txtPriCurrent.Text)
				WriteLine(2, txtDutyCyc.Text)
				WriteLine(2, txtRatio.Text)
				WriteLine(2, txtCurDens.Text)
				If optFperm.Checked = True Then
					intMatType = 1
				ElseIf optJperm.Checked = True Then 
					intMatType = 2
				ElseIf optWperm.Checked = True Then 
					intMatType = 3
				End If
				WriteLine(2, intMatType)
				If opt1mil.Checked = True Then
					intThickness = 1
				ElseIf opt2mil.Checked = True Then 
					intThickness = 2
				ElseIf opt4mil.Checked = True Then 
					intThickness = 4
				End If
				WriteLine(2, intThickness)
			Case 3
				WriteLine(2, txtVoltage.Text)
				WriteLine(2, txtFrequency.Text)
				WriteLine(2, txtPriCurrent.Text)
				WriteLine(2, txtDutyCyc.Text)
				WriteLine(2, txtRatio.Text)
				WriteLine(2, txtCurDens.Text)
				If optFperm.Checked = True Then
					intMatType = 1
				ElseIf optJperm.Checked = True Then 
					intMatType = 2
				ElseIf optWperm.Checked = True Then 
					intMatType = 3
				End If
				WriteLine(2, intMatType)
				cmnDialog1Open.FileName = strFilename
				cmnDialog1Save.FileName = strFilename
			Case 4
				WriteLine(2, txtVoltage.Text)
				WriteLine(2, txtFrequency.Text)
				WriteLine(2, txtPriCurrent.Text)
				WriteLine(2, txtDutyCyc.Text)
				WriteLine(2, txtRatio.Text)
				WriteLine(2, txtCurDens.Text)
				If optFperm.Checked = True Then
					intMatType = 1
				ElseIf optJperm.Checked = True Then 
					intMatType = 2
				ElseIf optWperm.Checked = True Then 
					intMatType = 3
				End If
				WriteLine(2, intMatType)
		End Select
		cmnDialog1Open.FileName = strFilename
		cmnDialog1Save.FileName = strFilename
		FileClose(2)
		Exit Sub
		
ErrHandler: 
		' User pressed Cancel button.
		Exit Sub
	End Sub
	
	Private Sub opt1mil_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles opt1mil.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Call cmdCalculate_Click(cmdCalculate, New System.EventArgs())
            End If
        End If
    End Sub
	
	Private Sub opt2mil_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles opt2mil.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Call cmdCalculate_Click(cmdCalculate, New System.EventArgs())
            End If
        End If
    End Sub
	
	Private Sub opt4mil_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles opt4mil.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Call cmdCalculate_Click(cmdCalculate, New System.EventArgs())
            End If
        End If
    End Sub
	
	Private Sub optFperm_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optFperm.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                If optTradCT.Checked = True Then
                    opt1mil.Visible = False
                    opt2mil.Checked = True
                    opt4mil.Visible = True
                End If
                Call cmdCalculate_Click(cmdCalculate, New System.EventArgs())
            End If
        End If
    End Sub
	
	Private Sub optHall_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optHall.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                ChDir((My.Application.Info.DirectoryPath))
                Me.Icon = New System.Drawing.Icon("Hall.ico")

                lblVout.Text = "Max Sensor Vout (V)"
                ToolTip1.SetToolTip(lblVout, "Output voltage of Hall Sensor at maximum current")
                txtVoltage.Text = CStr(2.0#)
                lblFrequency.Text = "Sensitivity (mV/G)"
                ToolTip1.SetToolTip(lblFrequency, "Resolution of the Hall Effect Sensor")
                txtFrequency.Text = CStr(10)
                lblIpri.Text = "Primary Current (A)"
                ToolTip1.SetToolTip(lblIpri, "Primary current to be sensed")
                txtPriCurrent.Text = CStr(100)
                lblCurDens.Text = "Primary Size (in)"
                ToolTip1.SetToolTip(lblCurDens, "OD (or largest diagonal dimension if rectangular) of primary wire")
                txtCurDens.Text = VB6.Format(0.1, "0.000")
                lblTurnsRatio.Text = "Primary Turns"
                ToolTip1.SetToolTip(lblTurnsRatio, "Number of Primary Turns")
                txtRatio.Text = CStr(1)
                lblDuty.Text = "Sensor Thickness (mm)"
                ToolTip1.SetToolTip(lblDuty, "Thickness of the Hall Effect Sensor")
                txtDutyCyc.Text = CStr(0.5)

                lblReqL.Text = "Gap Length (in)"
                lblWireSize.Text = "Effective Permeability"
                lblCore.Text = "Core P/N"
                lblActL.Text = "Sensitivity range (A*T/G)"
                lblResID.Visible = False
                txtResID.Visible = False

                lblAL.Visible = False
                txtAL.Visible = False

                optFperm.Text = "Molypermalloy"
                optJperm.Text = "Kool M" & Chr(181)
                optWperm.Text = "Ferrite (F Material)"

                frameThick.Visible = False
                opt1mil.Visible = False
                opt2mil.Visible = False
                opt4mil.Visible = False

                Call cmdCalculate_Click(cmdCalculate, New System.EventArgs())
            End If
        End If
    End Sub
	
	Private Sub optJperm_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optJperm.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                If optTradCT.Checked = True Then
                    opt1mil.Visible = False
                    opt2mil.Checked = True
                    opt4mil.Visible = True
                End If
                Call cmdCalculate_Click(cmdCalculate, New System.EventArgs())
            End If
        End If
    End Sub
	
	Private Sub optSMPS_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optSMPS.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                ChDir((My.Application.Info.DirectoryPath))
                Me.Icon = New System.Drawing.Icon("SMPS.ico")

                lblVout.Text = "Output Voltage (V)"
                ToolTip1.SetToolTip(lblVout, "Secondary voltage of the current transformer")
                txtVoltage.Text = CStr(0.5)
                lblFrequency.Text = "Frequency (kHz)"
                ToolTip1.SetToolTip(lblFrequency, "Switching frequency of the SMPS")
                txtFrequency.Text = CStr(50)
                lblIpri.Text = "Primary Current (A)"
                ToolTip1.SetToolTip(lblIpri, "Primary current into the current transformer")
                txtPriCurrent.Text = CStr(10)
                lblCurDens.Text = "Current Density (A/sq cm)"
                ToolTip1.SetToolTip(lblCurDens, "Current density for the secondary")
                txtCurDens.Text = CStr(400)
                lblTurnsRatio.Text = "Turns Ratio (1:xx)"
                ToolTip1.SetToolTip(lblTurnsRatio, "Number of Secondary Turns")
                txtRatio.Text = CStr(100)
                lblDuty.Text = "Duty Cycle"
                ToolTip1.SetToolTip(lblDuty, "Duty cycle of the SMPS")
                txtDutyCyc.Text = CStr(0.5)

                lblReqL.Text = "Required Min L (mH)"
                lblWireSize.Text = "Wire Size (AWG)"
                lblCore.Text = "Core P/N"
                lblActL.Text = "Actual L (mH)"
                lblResID.Text = "Residual ID (in)"
                lblResID.Visible = True
                txtResID.Visible = True

                lblAL.Visible = True
                txtAL.Visible = True

                optFperm.Text = "F (3K)"
                optJperm.Text = "J (5K)"
                optWperm.Text = "W (10K)"

                frameThick.Visible = False
                opt1mil.Visible = False
                opt2mil.Visible = False
                opt4mil.Visible = False

                optJperm.Checked = True
                Call cmdCalculate_Click(cmdCalculate, New System.EventArgs())
            End If
        End If
    End Sub
	
	Private Sub optTradCT_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optTradCT.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                ChDir((My.Application.Info.DirectoryPath))
                Me.Icon = New System.Drawing.Icon("TradCT.ico")

                lblVout.Text = "Burden R (Ohm)"
                ToolTip1.SetToolTip(lblVout, "Output, or burden, resistance")
                txtVoltage.Text = CStr(5)
                lblFrequency.Text = "Frequency (Hz)"
                ToolTip1.SetToolTip(lblFrequency, "Frequency of current being sensed")
                txtFrequency.Text = CStr(60)
                lblIpri.Text = "Primary Current (A)"
                ToolTip1.SetToolTip(lblIpri, "Primary current into the current transformer")
                txtPriCurrent.Text = CStr(10)
                lblCurDens.Text = "Current Density (A/sq cm)"
                ToolTip1.SetToolTip(lblCurDens, "Current density for the secondary")
                txtCurDens.Text = CStr(400)
                lblTurnsRatio.Text = "Turns Ratio (1:xx)"
                ToolTip1.SetToolTip(lblTurnsRatio, "Number of Secondary Turns")
                txtRatio.Text = CStr(100)
                lblDuty.Text = "Bmax (Gauss)"
                ToolTip1.SetToolTip(lblDuty, "Operating flux density of the core")
                txtDutyCyc.Text = CStr(5000)

                lblReqL.Text = "Accuracy"
                lblWireSize.Text = "Wire Size (AWG)"
                lblCore.Text = "Core P/N"
                lblActL.Text = "Total Losses (mW)"
                lblResID.Text = "Residual ID (in)"
                lblResID.Visible = True
                txtResID.Visible = True

                lblAL.Visible = False
                txtAL.Visible = False

                optFperm.Text = "K (Magnesil)"
                optJperm.Text = "H (48 Alloy)"
                optWperm.Text = "F (Supermalloy)"

                frameThick.Visible = True
                opt1mil.Visible = True
                opt2mil.Visible = True
                opt4mil.Visible = True

                optFperm.Checked = True
                Call optFperm_CheckedChanged(optFperm, New System.EventArgs())
            End If
        End If
    End Sub
	
	Private Sub optWperm_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optWperm.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                If optTradCT.Checked = True Then
                    opt1mil.Visible = True
                    opt2mil.Checked = True
                    opt4mil.Visible = False
                End If
                Call cmdCalculate_Click(cmdCalculate, New System.EventArgs())
            End If
        End If
    End Sub
End Class